<template>
  <div class="wrapper" :class="themeClasses">
    <div class="page-header" v-if="!fromApp">
      <div class="page-header-photo"></div>
      <div class="page-header-message">
        {{ $t("preorderTutorial.pageTitle") }}
      </div>
    </div>
    <div class="container">
      <div class="tutorial-header">
        <div class="title">{{ $t("preorderTutorial.takeoutSteps") }}</div>
        <div class="button-container">
          <template v-for="button in buttons">
            <preorder-tutorial-button
              @onAnchorClick="gotoAnchor"
              :icon="button.icon"
              :key="button.name"
            >
              <img
                slot="icon"
                class="icon"
                :src="
                  '/static/images/preorder-tutorial/icon-' +
                    button.icon +
                    '.svg'
                "
              />
              <template slot="text">{{
                $t("preorderTutorial.button." + button.name)
              }}</template>
            </preorder-tutorial-button>
            <div :key="button.icon" class="ic-proc-next"></div>
          </template>
        </div>
      </div>
      <div class="tutorial-body">
        <div class="section-text">{{ $t("preorderTutorial.details") }}</div>
        <accordion
          v-for="detailItem in detailItems"
          @onAnchorClick="gotoAnchor"
          :ref="detailItem.name"
          :key="`d-${detailItem.name}`"
          :iconText="detailItem.iconText"
          :iconTextBackground="true"
          :headerText="
            $t('preorderTutorial.detailItem.' + detailItem.name + '.header')
          "
          :content="detailItem.content"
        />
        <div class="section-text">{{ $t("preorderTutorial.faq") }}</div>
        <accordion
          v-for="faqItem in faqItems"
          @onAnchorClick="gotoAnchor"
          :ref="faqItem.name"
          :key="`f-${faqItem.name}`"
          :iconText="faqItem.iconText"
          :headerText="
            $t('preorderTutorial.faqItem.' + faqItem.name + '.header')
          "
          :content="faqItem.content"
        />
      </div>
    </div>
  </div>
</template>

<script>
import * as utils from "@/utils";
import { mapActions, mapState, mapGetters } from "vuex";
import PreorderTutorialButton from "@/components/Group/PreorderTutorialButton";
import Accordion from "@/components/Group/Accordion";

export default {
  components: {
    PreorderTutorialButton,
    Accordion
  },
  props: {
    anchorId: {
      type: String
    }
  },
  data() {
    return {
      buttons: [
        { name: "step1", icon: "login" },
        { name: "step2", icon: "selectPreordering" },
        { name: "step3", icon: "selectRestaurant" },
        { name: "step4", icon: "checkout" },
        { name: "step5", icon: "takeMeal" }
      ]
    };
  },

  mounted() {
    if (this.anchorId) {
      setTimeout(() => {
        this.gotoAnchor(`#${this.anchorId}`);
      }, 100);
    }
  },

  methods: {
    ...mapActions("account", ["startLogin"]),
    gotoAnchor(hash) {
      switch (hash) {
        case "#loginPopup":
          if (!this.account) {
            this.startLogin();
          }
          break;
        case "#preorderHistory":
          if (!this.account) {
            this.startLogin({
              finishAction: ["callRouterMethod", "push", "/account/preorder"]
            });
          } else {
            this.$router.push(`/account/preorder`);
          }
          break;
        default: {
          let element = this.$refs[hash.replace("#", "")][0];
          element.expand();
          let top = element.$el.offsetTop;
          window.scrollTo(0, top);
          break;
        }
      }
    }
  },

  computed: {
    ...mapGetters("theme", ["themeClasses"]),
    ...mapState("group", ["restaurants", "loading"]),
    ...mapState("account", ["account"]),
    ...mapState(["isMobile", "locale"]),

    fromApp() {
      return this.account && this.account.fromApp;
    },

    detailItems() {
      const device = this.isMobile ? "mobile" : "desktop";
      // const local = 'zh-TW'; // Reserve for en-US screenshot
      let items = [
        {
          name: "login",
          contentCount: 1,
          anchors: {
            "0": {
              signIn: "#loginPopup",
              signUp: "https://vipcard.skm.com.tw/rsv/join_step01.php"
            }
          }
        },
        {
          name: "selectBranch",
          contentCount: 1
        },
        { name: "selectRestaurant", contentCount: 4 },
        {
          name: "checkout",
          contentCount: 4,
          anchors: {
            "0": { payment: "#payment" },
            "1": {
              eInvoice: "#eInvoice",
              joinMember: "https://vipcard.skm.com.tw/"
            },
            "3": { cancelOrder: "#cancelOrder" }
          }
        },
        { name: "takeMeal", contentCount: 3 }
      ];
      const imagePath = "/static/images/preorder-tutorial/";
      const imageExt = "png";
      for (let i = 0; i < items.length; ++i) {
        const local = i !== 3 ? this.locale : "zh-TW"; // no english screenshot for step 4
        let item = items[i];
        item.iconText = String(i + 1);
        item.content = [];
        for (let j = 0; j < item.contentCount; ++j) {
          item.content.push({
            image: `${imagePath}${item.name}/${j +
              1}-${device}-${local}.${imageExt}`,
            // srcset: `${imagePath}${item.name}/${j +
            //   1}-${device}-${local}@2x.${imageExt} 2x,${imagePath}${
            //   item.name
            // }/${j + 1}-${device}-${local}@3x.${imageExt} 3x`,
            title: this.$t(
              `preorderTutorial.detailItem.${item.name}.step${j + 1}.title`
            ),
            text: this.$t(
              `preorderTutorial.detailItem.${item.name}.step${j + 1}.text`,
              item.anchors ? item.anchors[j] : ""
            )
          });
        }
      }
      return items;
    },
    faqItems() {
      let items = [
        { name: "terms", contentCount: 3 },
        {
          name: "meal",
          contentCount: 2
        },
        {
          name: "order",
          contentCount: 3
        },
        {
          name: "takeMeal",
          contentCount: 3
        },
        {
          name: "cancelOrder",
          contentCount: 3
        },
        {
          name: "other",
          contentCount: 1
        }
      ];
      for (let item of items) {
        item.iconText = "Q";
        item.content = [];
        for (let i = 0; i < item.contentCount; ++i) {
          item.content.push({
            title: this.$t(
              `preorderTutorial.faqItem.${item.name}.note${i + 1}.title`
            ),
            text: this.$t(
              `preorderTutorial.faqItem.${item.name}.note${i + 1}.text`,
              item.anchors ? item.anchors[i] : ""
            )
          });
        }
      }
      return items;
    }
  }
};
</script>

<style lang="scss" scoped>
.page-header {
  position: relative;
  height: 120px;
  line-height: 120px;
  text-align: center;
  color: $color-white;
  background-image: url("/static/images/records-header.png");
  background-size: cover;

  &::before {
    content: "";
    position: absolute;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    background: rgba(0, 0, 0, 0.3);
    z-index: 0;
  }

  @include media-breakpoint-up(md) {
    height: 240px;
    line-height: 240px;
  }
}

.container {
  margin-top: 40px;
  display: flex;
  flex-direction: column;
}

.tutorial-header {
  background-color: $color-white;
  width: 100%;
  .title {
    font-size: 28px;
    font-weight: 500;
    text-align: center;
    height: 40px;
    margin: 30px auto;
  }
  .button-container {
    width: 100%;
    display: inline-flex;
    flex-direction: row;
    justify-content: center;
    align-items: center;

    .ic-proc-next {
      display: block;
      width: 16px;
      height: 16px;
      background: url("/static/images/preorder-tutorial/ic-proc-next.svg");
      transform: translateY(-45px);
      margin: 0 8px;
      &:last-child {
        display: none;
      }
    }
  }
}

.tutorial-body {
  background-color: $color-genesis-white;
  width: 100%;
  display: flex;
  flex-direction: column;
  margin-bottom: 120px;

  .section-text {
    height: 24px;
    font-size: 28px;
    line-height: 0.86;
    margin: 30px 0px 10px 0px;
  }
}

.page-header-message {
  position: relative;
  z-index: 1;
  font-size: 40px;
  font-weight: 600;
}

@include media-breakpoint-down(md) {
  .container {
    margin-top: 0px;
    padding: 0;
  }
  .tutorial-header {
    .button-container {
      display: flex;
      flex-wrap: wrap;
      max-width: 725px;
      margin: auto;
    }
  }
  .tutorial-body {
    margin-bottom: 0px;
  }
}

@include media-breakpoint-down(sm) {
  .container {
    margin-top: 0px;
    padding: 0;
  }
  .tutorial-header {
    .button-container {
      display: flex;
      flex-direction: column;
      justify-content: flex-start;
      align-items: flex-start;
      margin-bottom: 40px;

      .ic-proc-next {
        display: block;
        width: 16px;
        height: 16px;
        background: url("/static/images/preorder-tutorial/ic-proc-next.svg");
        transform: translateX(72px) rotate(90deg);
        margin: 8px 0;
      }
    }
  }
  .tutorial-body {
    .section-text {
      font-size: 24px;
      text-align: center;
      margin: 40px 0px 20px 0px;
    }
  }
  .page-header-message {
    font-size: 30px;
  }
}
</style>
